//Note:
//If loading this project for the first time you'll run into errors due to
//the way I used a replacement DateTimePicker. I didn't install it in to the
//palette - I changed it after the fact. So to load the project, you'll need
//to first edit this very file in Notepad and:
//a) change the two occurrences of
//   System.Windows.Forms.NullableDateTimePicker.DateTimePicker to
//   System.Windows.Forms.DateTimePicker
//b) delete the assignment of nil to the property NullValue
//The project should then load and compile, at which point you can change the 2
//System.Windows.Forms.DateTimePicker references back to
//System.Windows.Forms.NullableDateTimePicker.DateTimePicker
//The property will reappear of its own accord
//The purpose of the NullableDateTimePicker is to allow a DateTimePicker
//control to support null values, which it irritatingly doesn't by default

//To run the app, you'll need:
//1) Firebird, preferably, from http://firebirdsql.org, though you can probably
//   get away with InterBase given the simplistic nature of the SQL
//2) The Firebird ADO.NET provider for .NET 1.1 from
//   http://www.firebirdsql.org/index.php?op=files&id=netprovider

//To Do:
//1) Avoid hard-coded path for database file
//2) Work out why the 3 category combos are all the same.
//3) See whether the DataAdapter would have coped with running
//   the update queries against the Contacts table

unit Main;

interface

uses
  FirebirdSql.Data.Firebird,
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Resources,
  System.Windows.Forms.NullableDateTimePicker;

type
  MainForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    headerPanel: System.Windows.Forms.Panel;
    topLeftPictureBox: System.Windows.Forms.PictureBox;
    topRightPictureBox: System.Windows.Forms.PictureBox;
    topCentrePictureBox: System.Windows.Forms.PictureBox;
    leftPanel: System.Windows.Forms.Panel;
    mainClientPanel: System.Windows.Forms.Panel;
    categoryTabControl: System.Windows.Forms.TabControl;
    contactsTabControl: System.Windows.Forms.TabControl;
    contactsTabPage: System.Windows.Forms.TabPage;
    loginHeaderLabel: System.Windows.Forms.Label;
    loginPanel: System.Windows.Forms.Panel;
    userNameTextBox: System.Windows.Forms.TextBox;
    passwordTextBox: System.Windows.Forms.TextBox;
    userNameTextBoxLabel: System.Windows.Forms.Label;
    passwordTextBoxLabel: System.Windows.Forms.Label;
    loginButton: System.Windows.Forms.Button;
    newUserButton: System.Windows.Forms.Button;
    searchPanel: System.Windows.Forms.Panel;
    searchNextButton: System.Windows.Forms.Button;
    searchStartButton: System.Windows.Forms.Button;
    nameTextBoxLabel: System.Windows.Forms.Label;
    nameTextBox: System.Windows.Forms.TextBox;
    searchHeaderLabel: System.Windows.Forms.Label;
    contactsDataGrid: System.Windows.Forms.DataGrid;
    contactDetailsTabControl: System.Windows.Forms.TabControl;
    contactNotesTabPage: System.Windows.Forms.TabPage;
    contactNamesTabPage: System.Windows.Forms.TabPage;
    contactAddressTabPage: System.Windows.Forms.TabPage;
    contactMiscTabPage: System.Windows.Forms.TabPage;
    notesTextBox: System.Windows.Forms.TextBox;
    titleComboBoxLabel: System.Windows.Forms.Label;
    firstNameTextBoxLabel: System.Windows.Forms.Label;
    lastnameTextBoxLabel: System.Windows.Forms.Label;
    nicknameTextBoxLabel: System.Windows.Forms.Label;
    companyTextBoxLabel: System.Windows.Forms.Label;
    titleComboBox: System.Windows.Forms.ComboBox;
    firstNameTextBox: System.Windows.Forms.TextBox;
    lastNameTextBox: System.Windows.Forms.TextBox;
    nickNameTextBox: System.Windows.Forms.TextBox;
    companyTextBox: System.Windows.Forms.TextBox;
    miscGroupBox: System.Windows.Forms.GroupBox;
    categoriesGroupBox: System.Windows.Forms.GroupBox;
    dobDateTimePickerLabel: System.Windows.Forms.Label;
    dobDateTimePicker: System.Windows.Forms.NullableDateTimePicker.DateTimePicker;
    category1ComboLabel: System.Windows.Forms.Label;
    category2ComboLabel: System.Windows.Forms.Label;
    category3ComboLabel: System.Windows.Forms.Label;
    category1ComboBox: System.Windows.Forms.ComboBox;
    category2ComboBox: System.Windows.Forms.ComboBox;
    category3ComboBox: System.Windows.Forms.ComboBox;
    addressTabControl: System.Windows.Forms.TabControl;
    buildingTextBox: System.Windows.Forms.TextBox;
    streetTextBox: System.Windows.Forms.TextBox;
    villageTextBox: System.Windows.Forms.TextBox;
    townTextBox: System.Windows.Forms.TextBox;
    countyTextBox: System.Windows.Forms.TextBox;
    postCodeTextBox: System.Windows.Forms.TextBox;
    countryTextBox: System.Windows.Forms.TextBox;
    webSiteTextBox: System.Windows.Forms.TextBox;
    emailTextBox: System.Windows.Forms.TextBox;
    mobileTextBox: System.Windows.Forms.TextBox;
    telephoneTextBox: System.Windows.Forms.TextBox;
    buildingLabel: System.Windows.Forms.Label;
    streetLabel: System.Windows.Forms.Label;
    villageLabel: System.Windows.Forms.Label;
    townLabel: System.Windows.Forms.Label;
    countyLabel: System.Windows.Forms.Label;
    postCodeLabel: System.Windows.Forms.Label;
    countryLabel: System.Windows.Forms.Label;
    telephoneLabel: System.Windows.Forms.Label;
    mobileLabel: System.Windows.Forms.Label;
    emailLabel: System.Windows.Forms.Label;
    webSiteLabel: System.Windows.Forms.Label;
    categoryOpsPanel: System.Windows.Forms.Panel;
    contactOpsPanel: System.Windows.Forms.Panel;
    categoryOpsLabel: System.Windows.Forms.Label;
    contactOpsLabel: System.Windows.Forms.Label;
    newCategoryLinkLabel: System.Windows.Forms.LinkLabel;
    deleteCategoryLinkLabel: System.Windows.Forms.LinkLabel;
    editCategoryLinkLabel: System.Windows.Forms.LinkLabel;
    editContactLinkLabel: System.Windows.Forms.LinkLabel;
    deleteContactLinkLabel: System.Windows.Forms.LinkLabel;
    newContactLinkLabel: System.Windows.Forms.LinkLabel;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure categoryTabControl_SelectedIndexChanged(sender: System.Object; 
      e: System.EventArgs);
    procedure addressTabControl_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
    procedure newContactLinkLabel_LinkClicked(sender: System.Object; e: System.Windows.Forms.LinkLabelLinkClickedEventArgs);
    procedure deleteContactLinkLabel_LinkClicked(sender: System.Object; e: System.Windows.Forms.LinkLabelLinkClickedEventArgs);
    procedure editContactLinkLabel_LinkClicked(sender: System.Object; e: System.Windows.Forms.LinkLabelLinkClickedEventArgs);
    procedure searchStartButton_Click(sender: System.Object; e: System.EventArgs);
    procedure searchNextButton_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
    phlabConnection: FbConnection;
    phlabDataset: DataSet;
    titlesDataAdapter,
    categoryDataAdapter,
    addressTypesDataAdapter,
    contactsDataAdapter,
    contactDetailsDataAdapter: FbDataAdapter;
    titlesDataTable,
    categoryDataTable,
    addressTypesDataTable,
    contactsDataTable,
    contactDetailsDataTable: DataTable;
    contactsDataView,
    contactDetailsDataView: DataView;
    contactsCurrencyManager: CurrencyManager;
    contactsInsertCommand,
    contactsUpdateCommand,
    contactsDeleteCommand,
    controlSelectCommand: FbCommand;

    categoryList, addressTypeList: ArrayList;
    editingContact: Boolean;
    uiBackColours: array[Boolean] of Color;

    function ContactDisplayName(row: DataRow): String;
    procedure LoadContacts;
    procedure LoadSelectedAddress;
    procedure SaveChangesIfNeeded;
    procedure SearchForName(const name: String; searchStart: Boolean);
    procedure SetupControls(aControl: Control; readOnly: Boolean);
    procedure SetupTabs(theTabControl: TabControl; table: DataTable;
      list: ArrayList; keyField, displayField: String);
  public
    constructor Create;
    procedure ContactsCurrencyManagerScroll(Sender: &Object; e: EventArgs);
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(MainForm))]

implementation

uses
  System.Text;

{$AUTOBOX ON}

const
  //Uh-oh! Hard-coded path.....
  sDatabasePath = 'C:\Phlab\Delphi - .NET\Phlab.fdb';
  sSelectContacts = 'select C.*, T.Title from CONTACTS C left outer join Titles T on C.TitleNo = T.TitleNo';

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure MainForm.InitializeComponent;
var
  resources: System.Resources.ResourceManager;
begin
  resources := System.Resources.ResourceManager.Create(TypeOf(MainForm));
  Self.headerPanel := System.Windows.Forms.Panel.Create;
  Self.topCentrePictureBox := System.Windows.Forms.PictureBox.Create;
  Self.topRightPictureBox := System.Windows.Forms.PictureBox.Create;
  Self.topLeftPictureBox := System.Windows.Forms.PictureBox.Create;
  Self.leftPanel := System.Windows.Forms.Panel.Create;
  Self.searchPanel := System.Windows.Forms.Panel.Create;
  Self.searchNextButton := System.Windows.Forms.Button.Create;
  Self.searchStartButton := System.Windows.Forms.Button.Create;
  Self.nameTextBoxLabel := System.Windows.Forms.Label.Create;
  Self.nameTextBox := System.Windows.Forms.TextBox.Create;
  Self.searchHeaderLabel := System.Windows.Forms.Label.Create;
  Self.loginPanel := System.Windows.Forms.Panel.Create;
  Self.newUserButton := System.Windows.Forms.Button.Create;
  Self.loginButton := System.Windows.Forms.Button.Create;
  Self.passwordTextBoxLabel := System.Windows.Forms.Label.Create;
  Self.userNameTextBoxLabel := System.Windows.Forms.Label.Create;
  Self.passwordTextBox := System.Windows.Forms.TextBox.Create;
  Self.userNameTextBox := System.Windows.Forms.TextBox.Create;
  Self.loginHeaderLabel := System.Windows.Forms.Label.Create;
  Self.mainClientPanel := System.Windows.Forms.Panel.Create;
  Self.contactOpsPanel := System.Windows.Forms.Panel.Create;
  Self.editContactLinkLabel := System.Windows.Forms.LinkLabel.Create;
  Self.deleteContactLinkLabel := System.Windows.Forms.LinkLabel.Create;
  Self.newContactLinkLabel := System.Windows.Forms.LinkLabel.Create;
  Self.contactOpsLabel := System.Windows.Forms.Label.Create;
  Self.categoryOpsPanel := System.Windows.Forms.Panel.Create;
  Self.editCategoryLinkLabel := System.Windows.Forms.LinkLabel.Create;
  Self.deleteCategoryLinkLabel := System.Windows.Forms.LinkLabel.Create;
  Self.newCategoryLinkLabel := System.Windows.Forms.LinkLabel.Create;
  Self.categoryOpsLabel := System.Windows.Forms.Label.Create;
  Self.contactsTabControl := System.Windows.Forms.TabControl.Create;
  Self.contactsTabPage := System.Windows.Forms.TabPage.Create;
  Self.contactDetailsTabControl := System.Windows.Forms.TabControl.Create;
  Self.contactNotesTabPage := System.Windows.Forms.TabPage.Create;
  Self.notesTextBox := System.Windows.Forms.TextBox.Create;
  Self.contactNamesTabPage := System.Windows.Forms.TabPage.Create;
  Self.companyTextBox := System.Windows.Forms.TextBox.Create;
  Self.nickNameTextBox := System.Windows.Forms.TextBox.Create;
  Self.lastNameTextBox := System.Windows.Forms.TextBox.Create;
  Self.firstNameTextBox := System.Windows.Forms.TextBox.Create;
  Self.titleComboBox := System.Windows.Forms.ComboBox.Create;
  Self.companyTextBoxLabel := System.Windows.Forms.Label.Create;
  Self.nicknameTextBoxLabel := System.Windows.Forms.Label.Create;
  Self.lastnameTextBoxLabel := System.Windows.Forms.Label.Create;
  Self.firstNameTextBoxLabel := System.Windows.Forms.Label.Create;
  Self.titleComboBoxLabel := System.Windows.Forms.Label.Create;
  Self.contactAddressTabPage := System.Windows.Forms.TabPage.Create;
  Self.webSiteLabel := System.Windows.Forms.Label.Create;
  Self.emailLabel := System.Windows.Forms.Label.Create;
  Self.mobileLabel := System.Windows.Forms.Label.Create;
  Self.telephoneLabel := System.Windows.Forms.Label.Create;
  Self.countryLabel := System.Windows.Forms.Label.Create;
  Self.postCodeLabel := System.Windows.Forms.Label.Create;
  Self.countyLabel := System.Windows.Forms.Label.Create;
  Self.townLabel := System.Windows.Forms.Label.Create;
  Self.villageLabel := System.Windows.Forms.Label.Create;
  Self.streetLabel := System.Windows.Forms.Label.Create;
  Self.buildingLabel := System.Windows.Forms.Label.Create;
  Self.webSiteTextBox := System.Windows.Forms.TextBox.Create;
  Self.emailTextBox := System.Windows.Forms.TextBox.Create;
  Self.mobileTextBox := System.Windows.Forms.TextBox.Create;
  Self.telephoneTextBox := System.Windows.Forms.TextBox.Create;
  Self.countryTextBox := System.Windows.Forms.TextBox.Create;
  Self.postCodeTextBox := System.Windows.Forms.TextBox.Create;
  Self.countyTextBox := System.Windows.Forms.TextBox.Create;
  Self.townTextBox := System.Windows.Forms.TextBox.Create;
  Self.villageTextBox := System.Windows.Forms.TextBox.Create;
  Self.streetTextBox := System.Windows.Forms.TextBox.Create;
  Self.buildingTextBox := System.Windows.Forms.TextBox.Create;
  Self.addressTabControl := System.Windows.Forms.TabControl.Create;
  Self.contactMiscTabPage := System.Windows.Forms.TabPage.Create;
  Self.categoriesGroupBox := System.Windows.Forms.GroupBox.Create;
  Self.category3ComboBox := System.Windows.Forms.ComboBox.Create;
  Self.category2ComboBox := System.Windows.Forms.ComboBox.Create;
  Self.category1ComboBox := System.Windows.Forms.ComboBox.Create;
  Self.category3ComboLabel := System.Windows.Forms.Label.Create;
  Self.category2ComboLabel := System.Windows.Forms.Label.Create;
  Self.category1ComboLabel := System.Windows.Forms.Label.Create;
  Self.miscGroupBox := System.Windows.Forms.GroupBox.Create;
  Self.dobDateTimePicker := System.Windows.Forms.NullableDateTimePicker.DateTimePicker.Create;
  Self.dobDateTimePickerLabel := System.Windows.Forms.Label.Create;
  Self.contactsDataGrid := System.Windows.Forms.DataGrid.Create;
  Self.categoryTabControl := System.Windows.Forms.TabControl.Create;
  Self.headerPanel.SuspendLayout;
  Self.leftPanel.SuspendLayout;
  Self.searchPanel.SuspendLayout;
  Self.loginPanel.SuspendLayout;
  Self.mainClientPanel.SuspendLayout;
  Self.contactOpsPanel.SuspendLayout;
  Self.categoryOpsPanel.SuspendLayout;
  Self.contactsTabControl.SuspendLayout;
  Self.contactsTabPage.SuspendLayout;
  Self.contactDetailsTabControl.SuspendLayout;
  Self.contactNotesTabPage.SuspendLayout;
  Self.contactNamesTabPage.SuspendLayout;
  Self.contactAddressTabPage.SuspendLayout;
  Self.contactMiscTabPage.SuspendLayout;
  Self.categoriesGroupBox.SuspendLayout;
  Self.miscGroupBox.SuspendLayout;
  (System.ComponentModel.ISupportInitialize(Self.contactsDataGrid)).BeginInit;
  Self.SuspendLayout;
  // 
  // headerPanel
  // 
  Self.headerPanel.Controls.Add(Self.topCentrePictureBox);
  Self.headerPanel.Controls.Add(Self.topRightPictureBox);
  Self.headerPanel.Controls.Add(Self.topLeftPictureBox);
  Self.headerPanel.Dock := System.Windows.Forms.DockStyle.Top;
  Self.headerPanel.Location := System.Drawing.Point.Create(0, 0);
  Self.headerPanel.Name := 'headerPanel';
  Self.headerPanel.Size := System.Drawing.Size.Create(774, 56);
  Self.headerPanel.TabIndex := 0;
  // 
  // topCentrePictureBox
  // 
  Self.topCentrePictureBox.Dock := System.Windows.Forms.DockStyle.Fill;
  Self.topCentrePictureBox.Image := (System.Drawing.Image(resources.GetObject('t' +
    'opCentrePictureBox.Image')));
  Self.topCentrePictureBox.Location := System.Drawing.Point.Create(100, 0);
  Self.topCentrePictureBox.Name := 'topCentrePictureBox';
  Self.topCentrePictureBox.Size := System.Drawing.Size.Create(574, 56);
  Self.topCentrePictureBox.SizeMode := System.Windows.Forms.PictureBoxSizeMode.StretchImage;
  Self.topCentrePictureBox.TabIndex := 2;
  Self.topCentrePictureBox.TabStop := False;
  // 
  // topRightPictureBox
  // 
  Self.topRightPictureBox.Dock := System.Windows.Forms.DockStyle.Right;
  Self.topRightPictureBox.Image := (System.Drawing.Image(resources.GetObject('t' +
    'opRightPictureBox.Image')));
  Self.topRightPictureBox.Location := System.Drawing.Point.Create(674, 0);
  Self.topRightPictureBox.Name := 'topRightPictureBox';
  Self.topRightPictureBox.Size := System.Drawing.Size.Create(100, 56);
  Self.topRightPictureBox.TabIndex := 1;
  Self.topRightPictureBox.TabStop := False;
  // 
  // topLeftPictureBox
  // 
  Self.topLeftPictureBox.Dock := System.Windows.Forms.DockStyle.Left;
  Self.topLeftPictureBox.Image := (System.Drawing.Image(resources.GetObject('t' +
    'opLeftPictureBox.Image')));
  Self.topLeftPictureBox.Location := System.Drawing.Point.Create(0, 0);
  Self.topLeftPictureBox.Name := 'topLeftPictureBox';
  Self.topLeftPictureBox.Size := System.Drawing.Size.Create(100, 56);
  Self.topLeftPictureBox.TabIndex := 0;
  Self.topLeftPictureBox.TabStop := False;
  // 
  // leftPanel
  // 
  Self.leftPanel.AccessibleDescription := 'v';
  Self.leftPanel.Controls.Add(Self.searchPanel);
  Self.leftPanel.Controls.Add(Self.searchHeaderLabel);
  Self.leftPanel.Controls.Add(Self.loginPanel);
  Self.leftPanel.Controls.Add(Self.loginHeaderLabel);
  Self.leftPanel.Dock := System.Windows.Forms.DockStyle.Left;
  Self.leftPanel.Location := System.Drawing.Point.Create(0, 56);
  Self.leftPanel.Name := 'leftPanel';
  Self.leftPanel.Size := System.Drawing.Size.Create(184, 439);
  Self.leftPanel.TabIndex := 2;
  // 
  // searchPanel
  // 
  Self.searchPanel.BackColor := System.Drawing.SystemColors.Control;
  Self.searchPanel.Controls.Add(Self.searchNextButton);
  Self.searchPanel.Controls.Add(Self.searchStartButton);
  Self.searchPanel.Controls.Add(Self.nameTextBoxLabel);
  Self.searchPanel.Controls.Add(Self.nameTextBox);
  Self.searchPanel.Location := System.Drawing.Point.Create(16, 272);
  Self.searchPanel.Name := 'searchPanel';
  Self.searchPanel.Size := System.Drawing.Size.Create(152, 131);
  Self.searchPanel.TabIndex := 3;
  // 
  // searchNextButton
  // 
  Self.searchNextButton.Location := System.Drawing.Point.Create(29, 96);
  Self.searchNextButton.Name := 'searchNextButton';
  Self.searchNextButton.Size := System.Drawing.Size.Create(96, 23);
  Self.searchNextButton.TabIndex := 5;
  Self.searchNextButton.Text := 'Search Next';
  Include(Self.searchNextButton.Click, Self.searchNextButton_Click);
  // 
  // searchStartButton
  // 
  Self.searchStartButton.Location := System.Drawing.Point.Create(29, 64);
  Self.searchStartButton.Name := 'searchStartButton';
  Self.searchStartButton.Size := System.Drawing.Size.Create(96, 23);
  Self.searchStartButton.TabIndex := 4;
  Self.searchStartButton.Text := 'Start Search';
  Include(Self.searchStartButton.Click, Self.searchStartButton_Click);
  // 
  // nameTextBoxLabel
  // 
  Self.nameTextBoxLabel.Location := System.Drawing.Point.Create(16, 11);
  Self.nameTextBoxLabel.Name := 'nameTextBoxLabel';
  Self.nameTextBoxLabel.Size := System.Drawing.Size.Create(120, 16);
  Self.nameTextBoxLabel.TabIndex := 2;
  Self.nameTextBoxLabel.Text := 'Name';
  Self.nameTextBoxLabel.TextAlign := System.Drawing.ContentAlignment.TopCenter;
  // 
  // nameTextBox
  // 
  Self.nameTextBox.Location := System.Drawing.Point.Create(16, 27);
  Self.nameTextBox.Name := 'nameTextBox';
  Self.nameTextBox.Size := System.Drawing.Size.Create(120, 20);
  Self.nameTextBox.TabIndex := 0;
  Self.nameTextBox.Text := '';
  // 
  // searchHeaderLabel
  // 
  Self.searchHeaderLabel.BackColor := System.Drawing.Color.Maroon;
  Self.searchHeaderLabel.Font := System.Drawing.Font.Create('Arial', 10, System.Drawing.FontStyle.Regular, 
      System.Drawing.GraphicsUnit.Point, (Byte(0)));
  Self.searchHeaderLabel.ForeColor := System.Drawing.SystemColors.Window;
  Self.searchHeaderLabel.Location := System.Drawing.Point.Create(16, 248);
  Self.searchHeaderLabel.Name := 'searchHeaderLabel';
  Self.searchHeaderLabel.Size := System.Drawing.Size.Create(152, 23);
  Self.searchHeaderLabel.TabIndex := 2;
  Self.searchHeaderLabel.Text := 'Search';
  Self.searchHeaderLabel.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
  // 
  // loginPanel
  // 
  Self.loginPanel.BackColor := System.Drawing.SystemColors.Control;
  Self.loginPanel.Controls.Add(Self.newUserButton);
  Self.loginPanel.Controls.Add(Self.loginButton);
  Self.loginPanel.Controls.Add(Self.passwordTextBoxLabel);
  Self.loginPanel.Controls.Add(Self.userNameTextBoxLabel);
  Self.loginPanel.Controls.Add(Self.passwordTextBox);
  Self.loginPanel.Controls.Add(Self.userNameTextBox);
  Self.loginPanel.Location := System.Drawing.Point.Create(16, 48);
  Self.loginPanel.Name := 'loginPanel';
  Self.loginPanel.Size := System.Drawing.Size.Create(152, 160);
  Self.loginPanel.TabIndex := 1;
  // 
  // newUserButton
  // 
  Self.newUserButton.Location := System.Drawing.Point.Create(64, 128);
  Self.newUserButton.Name := 'newUserButton';
  Self.newUserButton.TabIndex := 5;
  Self.newUserButton.Text := 'New User';
  // 
  // loginButton
  // 
  Self.loginButton.Location := System.Drawing.Point.Create(64, 96);
  Self.loginButton.Name := 'loginButton';
  Self.loginButton.TabIndex := 4;
  Self.loginButton.Text := 'Login';
  // 
  // passwordTextBoxLabel
  // 
  Self.passwordTextBoxLabel.Location := System.Drawing.Point.Create(16, 51);
  Self.passwordTextBoxLabel.Name := 'passwordTextBoxLabel';
  Self.passwordTextBoxLabel.Size := System.Drawing.Size.Create(100, 16);
  Self.passwordTextBoxLabel.TabIndex := 3;
  Self.passwordTextBoxLabel.Text := 'Password:';
  // 
  // userNameTextBoxLabel
  // 
  Self.userNameTextBoxLabel.Location := System.Drawing.Point.Create(16, 11);
  Self.userNameTextBoxLabel.Name := 'userNameTextBoxLabel';
  Self.userNameTextBoxLabel.Size := System.Drawing.Size.Create(100, 16);
  Self.userNameTextBoxLabel.TabIndex := 2;
  Self.userNameTextBoxLabel.Text := 'User:';
  // 
  // passwordTextBox
  // 
  Self.passwordTextBox.Location := System.Drawing.Point.Create(16, 67);
  Self.passwordTextBox.Name := 'passwordTextBox';
  Self.passwordTextBox.Size := System.Drawing.Size.Create(120, 20);
  Self.passwordTextBox.TabIndex := 1;
  Self.passwordTextBox.Text := '';
  // 
  // userNameTextBox
  // 
  Self.userNameTextBox.Location := System.Drawing.Point.Create(16, 27);
  Self.userNameTextBox.Name := 'userNameTextBox';
  Self.userNameTextBox.Size := System.Drawing.Size.Create(120, 20);
  Self.userNameTextBox.TabIndex := 0;
  Self.userNameTextBox.Text := '';
  // 
  // loginHeaderLabel
  // 
  Self.loginHeaderLabel.BackColor := System.Drawing.SystemColors.ControlDark;
  Self.loginHeaderLabel.Font := System.Drawing.Font.Create('Arial', 10, System.Drawing.FontStyle.Regular, 
      System.Drawing.GraphicsUnit.Point, (Byte(0)));
  Self.loginHeaderLabel.ForeColor := System.Drawing.SystemColors.Window;
  Self.loginHeaderLabel.Location := System.Drawing.Point.Create(16, 24);
  Self.loginHeaderLabel.Name := 'loginHeaderLabel';
  Self.loginHeaderLabel.Size := System.Drawing.Size.Create(152, 23);
  Self.loginHeaderLabel.TabIndex := 0;
  Self.loginHeaderLabel.Text := 'Personal Login';
  Self.loginHeaderLabel.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
  // 
  // mainClientPanel
  // 
  Self.mainClientPanel.Controls.Add(Self.contactOpsPanel);
  Self.mainClientPanel.Controls.Add(Self.categoryOpsPanel);
  Self.mainClientPanel.Controls.Add(Self.contactsTabControl);
  Self.mainClientPanel.Controls.Add(Self.categoryTabControl);
  Self.mainClientPanel.Dock := System.Windows.Forms.DockStyle.Fill;
  Self.mainClientPanel.Location := System.Drawing.Point.Create(184, 56);
  Self.mainClientPanel.Name := 'mainClientPanel';
  Self.mainClientPanel.Size := System.Drawing.Size.Create(590, 439);
  Self.mainClientPanel.TabIndex := 3;
  // 
  // contactOpsPanel
  // 
  Self.contactOpsPanel.BackColor := System.Drawing.SystemColors.Control;
  Self.contactOpsPanel.Controls.Add(Self.editContactLinkLabel);
  Self.contactOpsPanel.Controls.Add(Self.deleteContactLinkLabel);
  Self.contactOpsPanel.Controls.Add(Self.newContactLinkLabel);
  Self.contactOpsPanel.Controls.Add(Self.contactOpsLabel);
  Self.contactOpsPanel.Location := System.Drawing.Point.Create(384, 48);
  Self.contactOpsPanel.Name := 'contactOpsPanel';
  Self.contactOpsPanel.Size := System.Drawing.Size.Create(184, 16);
  Self.contactOpsPanel.TabIndex := 4;
  // 
  // editContactLinkLabel
  // 
  Self.editContactLinkLabel.Location := System.Drawing.Point.Create(152, 0);
  Self.editContactLinkLabel.Name := 'editContactLinkLabel';
  Self.editContactLinkLabel.Size := System.Drawing.Size.Create(32, 16);
  Self.editContactLinkLabel.TabIndex := 6;
  Self.editContactLinkLabel.TabStop := True;
  Self.editContactLinkLabel.Text := 'Edit';
  Include(Self.editContactLinkLabel.LinkClicked, Self.editContactLinkLabel_LinkClicked);
  // 
  // deleteContactLinkLabel
  // 
  Self.deleteContactLinkLabel.Location := System.Drawing.Point.Create(108, 0);
  Self.deleteContactLinkLabel.Name := 'deleteContactLinkLabel';
  Self.deleteContactLinkLabel.Size := System.Drawing.Size.Create(40, 16);
  Self.deleteContactLinkLabel.TabIndex := 5;
  Self.deleteContactLinkLabel.TabStop := True;
  Self.deleteContactLinkLabel.Text := 'Delete';
  Include(Self.deleteContactLinkLabel.LinkClicked, Self.deleteContactLinkLabel_LinkClicked);
  // 
  // newContactLinkLabel
  // 
  Self.newContactLinkLabel.Location := System.Drawing.Point.Create(72, 0);
  Self.newContactLinkLabel.Name := 'newContactLinkLabel';
  Self.newContactLinkLabel.Size := System.Drawing.Size.Create(32, 16);
  Self.newContactLinkLabel.TabIndex := 4;
  Self.newContactLinkLabel.TabStop := True;
  Self.newContactLinkLabel.Text := 'New';
  Include(Self.newContactLinkLabel.LinkClicked, Self.newContactLinkLabel_LinkClicked);
  // 
  // contactOpsLabel
  // 
  Self.contactOpsLabel.Location := System.Drawing.Point.Create(13, 0);
  Self.contactOpsLabel.Name := 'contactOpsLabel';
  Self.contactOpsLabel.Size := System.Drawing.Size.Create(56, 16);
  Self.contactOpsLabel.TabIndex := 0;
  Self.contactOpsLabel.Text := 'Contact:';
  // 
  // categoryOpsPanel
  // 
  Self.categoryOpsPanel.BackColor := System.Drawing.SystemColors.Control;
  Self.categoryOpsPanel.Controls.Add(Self.editCategoryLinkLabel);
  Self.categoryOpsPanel.Controls.Add(Self.deleteCategoryLinkLabel);
  Self.categoryOpsPanel.Controls.Add(Self.newCategoryLinkLabel);
  Self.categoryOpsPanel.Controls.Add(Self.categoryOpsLabel);
  Self.categoryOpsPanel.Location := System.Drawing.Point.Create(384, 12);
  Self.categoryOpsPanel.Name := 'categoryOpsPanel';
  Self.categoryOpsPanel.Size := System.Drawing.Size.Create(184, 16);
  Self.categoryOpsPanel.TabIndex := 2;
  // 
  // editCategoryLinkLabel
  // 
  Self.editCategoryLinkLabel.Enabled := False;
  Self.editCategoryLinkLabel.Location := System.Drawing.Point.Create(152, 0);
  Self.editCategoryLinkLabel.Name := 'editCategoryLinkLabel';
  Self.editCategoryLinkLabel.Size := System.Drawing.Size.Create(32, 16);
  Self.editCategoryLinkLabel.TabIndex := 3;
  Self.editCategoryLinkLabel.TabStop := True;
  Self.editCategoryLinkLabel.Text := 'Edit';
  // 
  // deleteCategoryLinkLabel
  // 
  Self.deleteCategoryLinkLabel.Enabled := False;
  Self.deleteCategoryLinkLabel.Location := System.Drawing.Point.Create(108, 0);
  Self.deleteCategoryLinkLabel.Name := 'deleteCategoryLinkLabel';
  Self.deleteCategoryLinkLabel.Size := System.Drawing.Size.Create(40, 16);
  Self.deleteCategoryLinkLabel.TabIndex := 2;
  Self.deleteCategoryLinkLabel.TabStop := True;
  Self.deleteCategoryLinkLabel.Text := 'Delete';
  // 
  // newCategoryLinkLabel
  // 
  Self.newCategoryLinkLabel.Enabled := False;
  Self.newCategoryLinkLabel.Location := System.Drawing.Point.Create(72, 0);
  Self.newCategoryLinkLabel.Name := 'newCategoryLinkLabel';
  Self.newCategoryLinkLabel.Size := System.Drawing.Size.Create(32, 16);
  Self.newCategoryLinkLabel.TabIndex := 1;
  Self.newCategoryLinkLabel.TabStop := True;
  Self.newCategoryLinkLabel.Text := 'New';
  // 
  // categoryOpsLabel
  // 
  Self.categoryOpsLabel.Location := System.Drawing.Point.Create(13, 0);
  Self.categoryOpsLabel.Name := 'categoryOpsLabel';
  Self.categoryOpsLabel.Size := System.Drawing.Size.Create(56, 16);
  Self.categoryOpsLabel.TabIndex := 0;
  Self.categoryOpsLabel.Text := 'Category:';
  // 
  // contactsTabControl
  // 
  Self.contactsTabControl.Controls.Add(Self.contactsTabPage);
  Self.contactsTabControl.Location := System.Drawing.Point.Create(16, 48);
  Self.contactsTabControl.Name := 'contactsTabControl';
  Self.contactsTabControl.SelectedIndex := 0;
  Self.contactsTabControl.Size := System.Drawing.Size.Create(560, 376);
  Self.contactsTabControl.TabIndex := 1;
  // 
  // contactsTabPage
  // 
  Self.contactsTabPage.Controls.Add(Self.contactDetailsTabControl);
  Self.contactsTabPage.Controls.Add(Self.contactsDataGrid);
  Self.contactsTabPage.Location := System.Drawing.Point.Create(4, 22);
  Self.contactsTabPage.Name := 'contactsTabPage';
  Self.contactsTabPage.Size := System.Drawing.Size.Create(552, 350);
  Self.contactsTabPage.TabIndex := 0;
  Self.contactsTabPage.Text := 'Contacts';
  // 
  // contactDetailsTabControl
  // 
  Self.contactDetailsTabControl.Controls.Add(Self.contactNotesTabPage);
  Self.contactDetailsTabControl.Controls.Add(Self.contactNamesTabPage);
  Self.contactDetailsTabControl.Controls.Add(Self.contactAddressTabPage);
  Self.contactDetailsTabControl.Controls.Add(Self.contactMiscTabPage);
  Self.contactDetailsTabControl.Location := System.Drawing.Point.Create(248, 
      8);
  Self.contactDetailsTabControl.Name := 'contactDetailsTabControl';
  Self.contactDetailsTabControl.SelectedIndex := 0;
  Self.contactDetailsTabControl.Size := System.Drawing.Size.Create(296, 336);
  Self.contactDetailsTabControl.TabIndex := 1;
  // 
  // contactNotesTabPage
  // 
  Self.contactNotesTabPage.Controls.Add(Self.notesTextBox);
  Self.contactNotesTabPage.Location := System.Drawing.Point.Create(4, 22);
  Self.contactNotesTabPage.Name := 'contactNotesTabPage';
  Self.contactNotesTabPage.Size := System.Drawing.Size.Create(288, 310);
  Self.contactNotesTabPage.TabIndex := 0;
  Self.contactNotesTabPage.Text := 'Notes';
  // 
  // notesTextBox
  // 
  Self.notesTextBox.Dock := System.Windows.Forms.DockStyle.Fill;
  Self.notesTextBox.Location := System.Drawing.Point.Create(0, 0);
  Self.notesTextBox.Multiline := True;
  Self.notesTextBox.Name := 'notesTextBox';
  Self.notesTextBox.Size := System.Drawing.Size.Create(288, 310);
  Self.notesTextBox.TabIndex := 0;
  Self.notesTextBox.Text := '';
  // 
  // contactNamesTabPage
  // 
  Self.contactNamesTabPage.Controls.Add(Self.companyTextBox);
  Self.contactNamesTabPage.Controls.Add(Self.nickNameTextBox);
  Self.contactNamesTabPage.Controls.Add(Self.lastNameTextBox);
  Self.contactNamesTabPage.Controls.Add(Self.firstNameTextBox);
  Self.contactNamesTabPage.Controls.Add(Self.titleComboBox);
  Self.contactNamesTabPage.Controls.Add(Self.companyTextBoxLabel);
  Self.contactNamesTabPage.Controls.Add(Self.nicknameTextBoxLabel);
  Self.contactNamesTabPage.Controls.Add(Self.lastnameTextBoxLabel);
  Self.contactNamesTabPage.Controls.Add(Self.firstNameTextBoxLabel);
  Self.contactNamesTabPage.Controls.Add(Self.titleComboBoxLabel);
  Self.contactNamesTabPage.Location := System.Drawing.Point.Create(4, 22);
  Self.contactNamesTabPage.Name := 'contactNamesTabPage';
  Self.contactNamesTabPage.Size := System.Drawing.Size.Create(288, 310);
  Self.contactNamesTabPage.TabIndex := 1;
  Self.contactNamesTabPage.Text := 'Names';
  // 
  // companyTextBox
  // 
  Self.companyTextBox.Location := System.Drawing.Point.Create(88, 131);
  Self.companyTextBox.Name := 'companyTextBox';
  Self.companyTextBox.Size := System.Drawing.Size.Create(184, 20);
  Self.companyTextBox.TabIndex := 9;
  Self.companyTextBox.Text := '';
  // 
  // nickNameTextBox
  // 
  Self.nickNameTextBox.Location := System.Drawing.Point.Create(88, 85);
  Self.nickNameTextBox.Name := 'nickNameTextBox';
  Self.nickNameTextBox.Size := System.Drawing.Size.Create(184, 20);
  Self.nickNameTextBox.TabIndex := 8;
  Self.nickNameTextBox.Text := '';
  // 
  // lastNameTextBox
  // 
  Self.lastNameTextBox.Location := System.Drawing.Point.Create(88, 61);
  Self.lastNameTextBox.Name := 'lastNameTextBox';
  Self.lastNameTextBox.Size := System.Drawing.Size.Create(184, 20);
  Self.lastNameTextBox.TabIndex := 7;
  Self.lastNameTextBox.Text := '';
  // 
  // firstNameTextBox
  // 
  Self.firstNameTextBox.Location := System.Drawing.Point.Create(88, 37);
  Self.firstNameTextBox.Name := 'firstNameTextBox';
  Self.firstNameTextBox.Size := System.Drawing.Size.Create(184, 20);
  Self.firstNameTextBox.TabIndex := 6;
  Self.firstNameTextBox.Text := '';
  // 
  // titleComboBox
  // 
  Self.titleComboBox.Location := System.Drawing.Point.Create(88, 12);
  Self.titleComboBox.Name := 'titleComboBox';
  Self.titleComboBox.Size := System.Drawing.Size.Create(96, 21);
  Self.titleComboBox.TabIndex := 5;
  Self.titleComboBox.Text := 'ComboBox1';
  // 
  // companyTextBoxLabel
  // 
  Self.companyTextBoxLabel.Location := System.Drawing.Point.Create(16, 136);
  Self.companyTextBoxLabel.Name := 'companyTextBoxLabel';
  Self.companyTextBoxLabel.Size := System.Drawing.Size.Create(64, 16);
  Self.companyTextBoxLabel.TabIndex := 4;
  Self.companyTextBoxLabel.Text := 'Company:';
  // 
  // nicknameTextBoxLabel
  // 
  Self.nicknameTextBoxLabel.Location := System.Drawing.Point.Create(16, 90);
  Self.nicknameTextBoxLabel.Name := 'nicknameTextBoxLabel';
  Self.nicknameTextBoxLabel.Size := System.Drawing.Size.Create(64, 16);
  Self.nicknameTextBoxLabel.TabIndex := 3;
  Self.nicknameTextBoxLabel.Text := 'Nickname:';
  // 
  // lastnameTextBoxLabel
  // 
  Self.lastnameTextBoxLabel.Location := System.Drawing.Point.Create(16, 66);
  Self.lastnameTextBoxLabel.Name := 'lastnameTextBoxLabel';
  Self.lastnameTextBoxLabel.Size := System.Drawing.Size.Create(64, 16);
  Self.lastnameTextBoxLabel.TabIndex := 2;
  Self.lastnameTextBoxLabel.Text := 'Last Name:';
  // 
  // firstNameTextBoxLabel
  // 
  Self.firstNameTextBoxLabel.Location := System.Drawing.Point.Create(16, 42);
  Self.firstNameTextBoxLabel.Name := 'firstNameTextBoxLabel';
  Self.firstNameTextBoxLabel.Size := System.Drawing.Size.Create(64, 16);
  Self.firstNameTextBoxLabel.TabIndex := 1;
  Self.firstNameTextBoxLabel.Text := 'First Name:';
  // 
  // titleComboBoxLabel
  // 
  Self.titleComboBoxLabel.Location := System.Drawing.Point.Create(16, 18);
  Self.titleComboBoxLabel.Name := 'titleComboBoxLabel';
  Self.titleComboBoxLabel.Size := System.Drawing.Size.Create(64, 16);
  Self.titleComboBoxLabel.TabIndex := 0;
  Self.titleComboBoxLabel.Text := 'Title:';
  // 
  // contactAddressTabPage
  // 
  Self.contactAddressTabPage.Controls.Add(Self.webSiteLabel);
  Self.contactAddressTabPage.Controls.Add(Self.emailLabel);
  Self.contactAddressTabPage.Controls.Add(Self.mobileLabel);
  Self.contactAddressTabPage.Controls.Add(Self.telephoneLabel);
  Self.contactAddressTabPage.Controls.Add(Self.countryLabel);
  Self.contactAddressTabPage.Controls.Add(Self.postCodeLabel);
  Self.contactAddressTabPage.Controls.Add(Self.countyLabel);
  Self.contactAddressTabPage.Controls.Add(Self.townLabel);
  Self.contactAddressTabPage.Controls.Add(Self.villageLabel);
  Self.contactAddressTabPage.Controls.Add(Self.streetLabel);
  Self.contactAddressTabPage.Controls.Add(Self.buildingLabel);
  Self.contactAddressTabPage.Controls.Add(Self.webSiteTextBox);
  Self.contactAddressTabPage.Controls.Add(Self.emailTextBox);
  Self.contactAddressTabPage.Controls.Add(Self.mobileTextBox);
  Self.contactAddressTabPage.Controls.Add(Self.telephoneTextBox);
  Self.contactAddressTabPage.Controls.Add(Self.countryTextBox);
  Self.contactAddressTabPage.Controls.Add(Self.postCodeTextBox);
  Self.contactAddressTabPage.Controls.Add(Self.countyTextBox);
  Self.contactAddressTabPage.Controls.Add(Self.townTextBox);
  Self.contactAddressTabPage.Controls.Add(Self.villageTextBox);
  Self.contactAddressTabPage.Controls.Add(Self.streetTextBox);
  Self.contactAddressTabPage.Controls.Add(Self.buildingTextBox);
  Self.contactAddressTabPage.Controls.Add(Self.addressTabControl);
  Self.contactAddressTabPage.Location := System.Drawing.Point.Create(4, 22);
  Self.contactAddressTabPage.Name := 'contactAddressTabPage';
  Self.contactAddressTabPage.Size := System.Drawing.Size.Create(288, 310);
  Self.contactAddressTabPage.TabIndex := 2;
  Self.contactAddressTabPage.Text := 'Address/Comms';
  // 
  // webSiteLabel
  // 
  Self.webSiteLabel.Location := System.Drawing.Point.Create(8, 280);
  Self.webSiteLabel.Name := 'webSiteLabel';
  Self.webSiteLabel.Size := System.Drawing.Size.Create(72, 16);
  Self.webSiteLabel.TabIndex := 22;
  Self.webSiteLabel.Text := 'Web Site';
  // 
  // emailLabel
  // 
  Self.emailLabel.Location := System.Drawing.Point.Create(8, 256);
  Self.emailLabel.Name := 'emailLabel';
  Self.emailLabel.Size := System.Drawing.Size.Create(72, 16);
  Self.emailLabel.TabIndex := 21;
  Self.emailLabel.Text := 'Email';
  // 
  // mobileLabel
  // 
  Self.mobileLabel.Location := System.Drawing.Point.Create(8, 232);
  Self.mobileLabel.Name := 'mobileLabel';
  Self.mobileLabel.Size := System.Drawing.Size.Create(72, 16);
  Self.mobileLabel.TabIndex := 20;
  Self.mobileLabel.Text := 'Mobile';
  // 
  // telephoneLabel
  // 
  Self.telephoneLabel.Location := System.Drawing.Point.Create(8, 208);
  Self.telephoneLabel.Name := 'telephoneLabel';
  Self.telephoneLabel.Size := System.Drawing.Size.Create(72, 16);
  Self.telephoneLabel.TabIndex := 19;
  Self.telephoneLabel.Text := 'Telephone';
  // 
  // countryLabel
  // 
  Self.countryLabel.Location := System.Drawing.Point.Create(8, 184);
  Self.countryLabel.Name := 'countryLabel';
  Self.countryLabel.Size := System.Drawing.Size.Create(72, 16);
  Self.countryLabel.TabIndex := 18;
  Self.countryLabel.Text := 'Country';
  // 
  // postCodeLabel
  // 
  Self.postCodeLabel.Location := System.Drawing.Point.Create(8, 160);
  Self.postCodeLabel.Name := 'postCodeLabel';
  Self.postCodeLabel.Size := System.Drawing.Size.Create(72, 16);
  Self.postCodeLabel.TabIndex := 17;
  Self.postCodeLabel.Text := 'Post Code';
  // 
  // countyLabel
  // 
  Self.countyLabel.Location := System.Drawing.Point.Create(8, 136);
  Self.countyLabel.Name := 'countyLabel';
  Self.countyLabel.Size := System.Drawing.Size.Create(72, 16);
  Self.countyLabel.TabIndex := 16;
  Self.countyLabel.Text := 'County/State';
  // 
  // townLabel
  // 
  Self.townLabel.Location := System.Drawing.Point.Create(8, 112);
  Self.townLabel.Name := 'townLabel';
  Self.townLabel.Size := System.Drawing.Size.Create(72, 16);
  Self.townLabel.TabIndex := 15;
  Self.townLabel.Text := 'Town';
  // 
  // villageLabel
  // 
  Self.villageLabel.Location := System.Drawing.Point.Create(8, 88);
  Self.villageLabel.Name := 'villageLabel';
  Self.villageLabel.Size := System.Drawing.Size.Create(72, 16);
  Self.villageLabel.TabIndex := 14;
  Self.villageLabel.Text := 'Village';
  // 
  // streetLabel
  // 
  Self.streetLabel.Location := System.Drawing.Point.Create(8, 64);
  Self.streetLabel.Name := 'streetLabel';
  Self.streetLabel.Size := System.Drawing.Size.Create(72, 16);
  Self.streetLabel.TabIndex := 13;
  Self.streetLabel.Text := 'Street';
  // 
  // buildingLabel
  // 
  Self.buildingLabel.Location := System.Drawing.Point.Create(8, 42);
  Self.buildingLabel.Name := 'buildingLabel';
  Self.buildingLabel.Size := System.Drawing.Size.Create(72, 16);
  Self.buildingLabel.TabIndex := 12;
  Self.buildingLabel.Tag := '';
  Self.buildingLabel.Text := 'Building';
  // 
  // webSiteTextBox
  // 
  Self.webSiteTextBox.Location := System.Drawing.Point.Create(79, 280);
  Self.webSiteTextBox.Name := 'webSiteTextBox';
  Self.webSiteTextBox.Size := System.Drawing.Size.Create(200, 20);
  Self.webSiteTextBox.TabIndex := 11;
  Self.webSiteTextBox.Text := '';
  // 
  // emailTextBox
  // 
  Self.emailTextBox.Location := System.Drawing.Point.Create(79, 256);
  Self.emailTextBox.Name := 'emailTextBox';
  Self.emailTextBox.Size := System.Drawing.Size.Create(200, 20);
  Self.emailTextBox.TabIndex := 10;
  Self.emailTextBox.Text := '';
  // 
  // mobileTextBox
  // 
  Self.mobileTextBox.Location := System.Drawing.Point.Create(79, 232);
  Self.mobileTextBox.Name := 'mobileTextBox';
  Self.mobileTextBox.Size := System.Drawing.Size.Create(200, 20);
  Self.mobileTextBox.TabIndex := 9;
  Self.mobileTextBox.Text := '';
  // 
  // telephoneTextBox
  // 
  Self.telephoneTextBox.Location := System.Drawing.Point.Create(79, 208);
  Self.telephoneTextBox.Name := 'telephoneTextBox';
  Self.telephoneTextBox.Size := System.Drawing.Size.Create(200, 20);
  Self.telephoneTextBox.TabIndex := 8;
  Self.telephoneTextBox.Text := '';
  // 
  // countryTextBox
  // 
  Self.countryTextBox.Location := System.Drawing.Point.Create(79, 184);
  Self.countryTextBox.Name := 'countryTextBox';
  Self.countryTextBox.Size := System.Drawing.Size.Create(200, 20);
  Self.countryTextBox.TabIndex := 7;
  Self.countryTextBox.Text := '';
  // 
  // postCodeTextBox
  // 
  Self.postCodeTextBox.Location := System.Drawing.Point.Create(79, 160);
  Self.postCodeTextBox.Name := 'postCodeTextBox';
  Self.postCodeTextBox.Size := System.Drawing.Size.Create(200, 20);
  Self.postCodeTextBox.TabIndex := 6;
  Self.postCodeTextBox.Text := '';
  // 
  // countyTextBox
  // 
  Self.countyTextBox.Location := System.Drawing.Point.Create(79, 136);
  Self.countyTextBox.Name := 'countyTextBox';
  Self.countyTextBox.Size := System.Drawing.Size.Create(200, 20);
  Self.countyTextBox.TabIndex := 5;
  Self.countyTextBox.Text := '';
  // 
  // townTextBox
  // 
  Self.townTextBox.Location := System.Drawing.Point.Create(79, 112);
  Self.townTextBox.Name := 'townTextBox';
  Self.townTextBox.Size := System.Drawing.Size.Create(200, 20);
  Self.townTextBox.TabIndex := 4;
  Self.townTextBox.Text := '';
  // 
  // villageTextBox
  // 
  Self.villageTextBox.Location := System.Drawing.Point.Create(79, 88);
  Self.villageTextBox.Name := 'villageTextBox';
  Self.villageTextBox.Size := System.Drawing.Size.Create(200, 20);
  Self.villageTextBox.TabIndex := 3;
  Self.villageTextBox.Text := '';
  // 
  // streetTextBox
  // 
  Self.streetTextBox.Location := System.Drawing.Point.Create(79, 64);
  Self.streetTextBox.Name := 'streetTextBox';
  Self.streetTextBox.Size := System.Drawing.Size.Create(200, 20);
  Self.streetTextBox.TabIndex := 2;
  Self.streetTextBox.Text := '';
  // 
  // buildingTextBox
  // 
  Self.buildingTextBox.Location := System.Drawing.Point.Create(79, 40);
  Self.buildingTextBox.Name := 'buildingTextBox';
  Self.buildingTextBox.Size := System.Drawing.Size.Create(200, 20);
  Self.buildingTextBox.TabIndex := 1;
  Self.buildingTextBox.Text := '';
  // 
  // addressTabControl
  // 
  Self.addressTabControl.Location := System.Drawing.Point.Create(8, 8);
  Self.addressTabControl.Name := 'addressTabControl';
  Self.addressTabControl.SelectedIndex := 0;
  Self.addressTabControl.Size := System.Drawing.Size.Create(272, 24);
  Self.addressTabControl.TabIndex := 0;
  Include(Self.addressTabControl.SelectedIndexChanged, Self.addressTabControl_SelectedIndexChanged);
  // 
  // contactMiscTabPage
  // 
  Self.contactMiscTabPage.Controls.Add(Self.categoriesGroupBox);
  Self.contactMiscTabPage.Controls.Add(Self.miscGroupBox);
  Self.contactMiscTabPage.Location := System.Drawing.Point.Create(4, 22);
  Self.contactMiscTabPage.Name := 'contactMiscTabPage';
  Self.contactMiscTabPage.Size := System.Drawing.Size.Create(288, 310);
  Self.contactMiscTabPage.TabIndex := 3;
  Self.contactMiscTabPage.Text := 'Misc';
  // 
  // categoriesGroupBox
  // 
  Self.categoriesGroupBox.Controls.Add(Self.category3ComboBox);
  Self.categoriesGroupBox.Controls.Add(Self.category2ComboBox);
  Self.categoriesGroupBox.Controls.Add(Self.category1ComboBox);
  Self.categoriesGroupBox.Controls.Add(Self.category3ComboLabel);
  Self.categoriesGroupBox.Controls.Add(Self.category2ComboLabel);
  Self.categoriesGroupBox.Controls.Add(Self.category1ComboLabel);
  Self.categoriesGroupBox.Location := System.Drawing.Point.Create(16, 152);
  Self.categoriesGroupBox.Name := 'categoriesGroupBox';
  Self.categoriesGroupBox.Size := System.Drawing.Size.Create(256, 144);
  Self.categoriesGroupBox.TabIndex := 1;
  Self.categoriesGroupBox.TabStop := False;
  Self.categoriesGroupBox.Text := 'Categories';
  // 
  // category3ComboBox
  // 
  Self.category3ComboBox.Location := System.Drawing.Point.Create(104, 104);
  Self.category3ComboBox.Name := 'category3ComboBox';
  Self.category3ComboBox.Size := System.Drawing.Size.Create(121, 21);
  Self.category3ComboBox.TabIndex := 5;
  Self.category3ComboBox.Text := 'ComboBox3';
  // 
  // category2ComboBox
  // 
  Self.category2ComboBox.Location := System.Drawing.Point.Create(104, 64);
  Self.category2ComboBox.Name := 'category2ComboBox';
  Self.category2ComboBox.Size := System.Drawing.Size.Create(121, 21);
  Self.category2ComboBox.TabIndex := 4;
  Self.category2ComboBox.Text := 'ComboBox2';
  // 
  // category1ComboBox
  // 
  Self.category1ComboBox.Location := System.Drawing.Point.Create(104, 24);
  Self.category1ComboBox.Name := 'category1ComboBox';
  Self.category1ComboBox.Size := System.Drawing.Size.Create(121, 21);
  Self.category1ComboBox.TabIndex := 3;
  Self.category1ComboBox.Text := 'ComboBox1';
  // 
  // category3ComboLabel
  // 
  Self.category3ComboLabel.Location := System.Drawing.Point.Create(24, 107);
  Self.category3ComboLabel.Name := 'category3ComboLabel';
  Self.category3ComboLabel.Size := System.Drawing.Size.Create(72, 23);
  Self.category3ComboLabel.TabIndex := 2;
  Self.category3ComboLabel.Text := 'Category 3:';
  // 
  // category2ComboLabel
  // 
  Self.category2ComboLabel.Location := System.Drawing.Point.Create(24, 67);
  Self.category2ComboLabel.Name := 'category2ComboLabel';
  Self.category2ComboLabel.Size := System.Drawing.Size.Create(72, 23);
  Self.category2ComboLabel.TabIndex := 1;
  Self.category2ComboLabel.Text := 'Category 2:';
  // 
  // category1ComboLabel
  // 
  Self.category1ComboLabel.Location := System.Drawing.Point.Create(24, 27);
  Self.category1ComboLabel.Name := 'category1ComboLabel';
  Self.category1ComboLabel.Size := System.Drawing.Size.Create(72, 23);
  Self.category1ComboLabel.TabIndex := 0;
  Self.category1ComboLabel.Text := 'Category 1:';
  // 
  // miscGroupBox
  // 
  Self.miscGroupBox.Controls.Add(Self.dobDateTimePicker);
  Self.miscGroupBox.Controls.Add(Self.dobDateTimePickerLabel);
  Self.miscGroupBox.Location := System.Drawing.Point.Create(16, 16);
  Self.miscGroupBox.Name := 'miscGroupBox';
  Self.miscGroupBox.Size := System.Drawing.Size.Create(256, 120);
  Self.miscGroupBox.TabIndex := 0;
  Self.miscGroupBox.TabStop := False;
  Self.miscGroupBox.Text := 'Miscellaneous';
  // 
  // dobDateTimePicker
  // 
  Self.dobDateTimePicker.Format := System.Windows.Forms.DateTimePickerFormat.Long;
  Self.dobDateTimePicker.Location := System.Drawing.Point.Create(104, 32);
  Self.dobDateTimePicker.MaxDate := System.DateTime.Create(2010, 12, 31, 0, 0, 
      0, 0);
  Self.dobDateTimePicker.MinDate := System.DateTime.Create(1800, 1, 1, 0, 0, 
      0, 0);
  Self.dobDateTimePicker.Name := 'dobDateTimePicker';
  Self.dobDateTimePicker.NullValue := nil;
  Self.dobDateTimePicker.Size := System.Drawing.Size.Create(120, 20);
  Self.dobDateTimePicker.TabIndex := 1;
  Self.dobDateTimePicker.Value := System.DateTime.Create(2006, 7, 8, 14, 16, 
      34, 581);
  // 
  // dobDateTimePickerLabel
  // 
  Self.dobDateTimePickerLabel.Location := System.Drawing.Point.Create(16, 32);
  Self.dobDateTimePickerLabel.Name := 'dobDateTimePickerLabel';
  Self.dobDateTimePickerLabel.Size := System.Drawing.Size.Create(72, 23);
  Self.dobDateTimePickerLabel.TabIndex := 0;
  Self.dobDateTimePickerLabel.Text := 'Date of birth:';
  // 
  // contactsDataGrid
  // 
  Self.contactsDataGrid.AllowSorting := False;
  Self.contactsDataGrid.AlternatingBackColor := System.Drawing.Color.Gainsboro;
  Self.contactsDataGrid.BackColor := System.Drawing.Color.Silver;
  Self.contactsDataGrid.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.contactsDataGrid.CaptionBackColor := System.Drawing.Color.DarkSlateBlue;
  Self.contactsDataGrid.CaptionFont := System.Drawing.Font.Create('Tahoma', 8);
  Self.contactsDataGrid.CaptionForeColor := System.Drawing.Color.White;
  Self.contactsDataGrid.CaptionVisible := False;
  Self.contactsDataGrid.DataMember := '';
  Self.contactsDataGrid.FlatMode := True;
  Self.contactsDataGrid.ForeColor := System.Drawing.Color.Black;
  Self.contactsDataGrid.GridLineColor := System.Drawing.Color.White;
  Self.contactsDataGrid.HeaderBackColor := System.Drawing.Color.DarkGray;
  Self.contactsDataGrid.HeaderForeColor := System.Drawing.Color.Black;
  Self.contactsDataGrid.LinkColor := System.Drawing.Color.DarkSlateBlue;
  Self.contactsDataGrid.Location := System.Drawing.Point.Create(0, 8);
  Self.contactsDataGrid.Name := 'contactsDataGrid';
  Self.contactsDataGrid.ParentRowsBackColor := System.Drawing.Color.Black;
  Self.contactsDataGrid.ParentRowsForeColor := System.Drawing.Color.White;
  Self.contactsDataGrid.ReadOnly := True;
  Self.contactsDataGrid.RowHeadersVisible := False;
  Self.contactsDataGrid.SelectionBackColor := System.Drawing.Color.DarkSlateBlue;
  Self.contactsDataGrid.SelectionForeColor := System.Drawing.Color.White;
  Self.contactsDataGrid.Size := System.Drawing.Size.Create(240, 328);
  Self.contactsDataGrid.TabIndex := 0;
  // 
  // categoryTabControl
  // 
  Self.categoryTabControl.Location := System.Drawing.Point.Create(8, 8);
  Self.categoryTabControl.Name := 'categoryTabControl';
  Self.categoryTabControl.SelectedIndex := 0;
  Self.categoryTabControl.Size := System.Drawing.Size.Create(568, 24);
  Self.categoryTabControl.TabIndex := 0;
  Include(Self.categoryTabControl.SelectedIndexChanged, Self.categoryTabControl_SelectedIndexChanged);
  // 
  // MainForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.BackColor := System.Drawing.SystemColors.Window;
  Self.ClientSize := System.Drawing.Size.Create(774, 495);
  Self.Controls.Add(Self.mainClientPanel);
  Self.Controls.Add(Self.leftPanel);
  Self.Controls.Add(Self.headerPanel);
  Self.ForeColor := System.Drawing.SystemColors.ControlText;
  Self.FormBorderStyle := System.Windows.Forms.FormBorderStyle.FixedDialog;
  Self.Icon := (System.Drawing.Icon(resources.GetObject('$this.Icon')));
  Self.MaximizeBox := False;
  Self.Name := 'MainForm';
  Self.StartPosition := System.Windows.Forms.FormStartPosition.CenterScreen;
  Self.Text := 'The Common Address Boook';
  Self.headerPanel.ResumeLayout(False);
  Self.leftPanel.ResumeLayout(False);
  Self.searchPanel.ResumeLayout(False);
  Self.loginPanel.ResumeLayout(False);
  Self.mainClientPanel.ResumeLayout(False);
  Self.contactOpsPanel.ResumeLayout(False);
  Self.categoryOpsPanel.ResumeLayout(False);
  Self.contactsTabControl.ResumeLayout(False);
  Self.contactsTabPage.ResumeLayout(False);
  Self.contactDetailsTabControl.ResumeLayout(False);
  Self.contactNotesTabPage.ResumeLayout(False);
  Self.contactNamesTabPage.ResumeLayout(False);
  Self.contactAddressTabPage.ResumeLayout(False);
  Self.contactMiscTabPage.ResumeLayout(False);
  Self.categoriesGroupBox.ResumeLayout(False);
  Self.miscGroupBox.ResumeLayout(False);
  (System.ComponentModel.ISupportInitialize(Self.contactsDataGrid)).EndInit;
  Self.ResumeLayout(False);
end;
{$ENDREGION}

{$REGION 'MainForm.Dispose'}
procedure MainForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;
{$ENDREGION}

constructor MainForm.Create;
var
  contactDetailsCommandBuilder: FbCommandBuilder;
  dobBinding: Binding;
  ts: DataGridTableStyle;
  col: DataGridTextBoxColumn;
  mappingName: String;
begin
{$REGION 'Junk'}
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
{$ENDREGION}
  //Make controls look prettier on XP
  Application.EnableVisualStyles;
  uiBackColours[False] := SystemColors.Window;
  uiBackColours[True] := SystemColors.Control;
  SetupControls(mainClientPanel, True);
  contactDetailsTabControl.SelectedTab := contactNotesTabPage;

  categoryList := ArrayList.Create;
  addressTypeList := ArrayList.Create;

  phlabConnection := FbConnection.Create(
    System.String.Format(
    'User=SYSDBA;Password=masterke;Database={0};' +
    'DataSource=;Port=3050;Dialect=3;Charset=NONE;Role=;' +
    'Connection lifetime=0;Connection timeout=15;Pooling=True;' +
    'Packet Size=8192;Server Type=0', sDatabasePath));
  phlabConnection.Open;
  phlabDataset := DataSet.Create;

  titlesDataAdapter := FbDataAdapter.Create(
    'select * from TITLES order by DisplayNo', phlabConnection);
  titlesDataAdapter.Fill(phlabDataset, 'Titles');
  titlesDataTable := phlabDataset.Tables['Titles'];

  categoryDataAdapter := FbDataAdapter.Create(
    'select * from CATEGORY order by DisplayNo', phlabConnection);
  categoryDataAdapter.Fill(phlabDataset, 'Category');
  categoryDataTable := phlabDataset.Tables['Category'];

  addressTypesDataAdapter := FbDataAdapter.Create(
    'select * from ADDRESSTYPES order by DisplayNo', phlabConnection);
  addressTypesDataAdapter.Fill(phlabDataset, 'AddressTypes');
  addressTypesDataTable := phlabDataset.Tables['AddressTypes'];

  contactsDataAdapter := FbDataAdapter.Create(sSelectContacts, phlabConnection);
  phlabDataset.Tables.Add.TableName := 'Contacts';
  contactsDataTable := phlabDataset.Tables['Contacts'];
  contactsDataView := contactsDataTable.DefaultView;
  //Not using data adapter support for inserting records,
  //as the actual query that gets run is an outer join
  contactsInsertCommand := FbCommand.Create(
    'INSERT INTO CONTACTS (UserNo) VALUES (0)', phlabConnection);
  contactsDeleteCommand := FbCommand.Create(
    'DELETE FROM CONTACTS WHERE CONTACTNO = ?', phlabConnection);
  contactsDeleteCommand.Parameters.Add('@CONTACTNO', FbDbType.Integer);
  contactsUpdateCommand := FbCommand.Create(
    'UPDATE CONTACTS SET' +
    '  COMPANYNAME = ?, TITLENO = ?, FIRSTNAME = ?, LASTNAME = ?,' +
    '  NICKNAME = ?, DATEOFBIRTH = ?, CATEGORIES = ?, NOTES = ?,' +
    '  CATEGORIES = ?, CATEGORY1 = ?, CATEGORY2 = ?, CATEGORY3 = ?' +
    'WHERE CONTACTNO=?', phlabConnection);
  with contactsUpdateCommand.Parameters do
  begin
    Add('@COMPANYNAME', FbDbType.VarChar);
    Add('@TITLENO',     FbDbType.SmallInt);
    Add('@FIRSTNAME',   FbDbType.VarChar);
    Add('@LASTNAME',    FbDbType.VarChar);
    Add('@NICKNAME',    FbDbType.VarChar);
    Add('@DATEOFBIRTH', FbDbType.TimeStamp);
    Add('@CATEGORIES',  FbDbType.VarChar);
    Add('@NOTES',       FbDbType.VarChar);
    Add('@CATEGORIES',  FbDbType.VarChar);
    Add('@CATEGORY1',   FbDbType.SmallInt);
    Add('@CATEGORY2',   FbDbType.SmallInt);
    Add('@CATEGORY3',   FbDbType.SmallInt);
    Add('@CONTACTNO',   FbDbType.Integer);
  end;
  SetupTabs(categoryTabControl, categoryDataTable, categoryList,
    'CategoryNo', 'Category');

  //Now we need to bind the fields to the controls
  notesTextBox.DataBindings.Add('Text', contactsDataTable, 'NOTES');
  firstNameTextBox.DataBindings.Add('Text', contactsDataTable, 'FIRSTNAME');
  lastNameTextBox.DataBindings.Add('Text', contactsDataTable, 'LASTNAME');
  nickNameTextBox.DataBindings.Add('Text', contactsDataTable, 'NICKNAME');
  companyTextBox.DataBindings.Add('Text', contactsDataTable, 'COMPANYNAME');
  dobBinding := Binding.Create('Value', contactsDataTable, 'DATEOFBIRTH');
  dobDateTimePicker.DataBindings.Add(dobBinding);
  titleComboBox.DataSource := titlesDataTable;
  titleComboBox.DisplayMember := 'TITLE';
  titleComboBox.ValueMember := 'TITLENO';
  titleComboBox.DataBindings.Add('SelectedValue', contactsDataTable, 'TITLENO');
  //There is a problem in this data binding, as each combobox's SelectedValue
  //is kept in sync. As any are changed, the others change too.
  //Not what is required.
  category1ComboBox.DataSource := categoryDataTable;
  category1ComboBox.DisplayMember := 'CATEGORY';
  category1ComboBox.ValueMember := 'CATEGORYNO';
  category1ComboBox.DataBindings.Add('SelectedValue', contactsDataTable, 'CATEGORY1');
  category2ComboBox.DataSource := categoryDataTable;
  category2ComboBox.DisplayMember := 'CATEGORY';
  category2ComboBox.ValueMember := 'CATEGORYNO';
  category2ComboBox.DataBindings.Add('SelectedValue', contactsDataTable, 'CATEGORY2');
  category3ComboBox.DataSource := categoryDataTable;
  category3ComboBox.DisplayMember := 'CATEGORY';
  category3ComboBox.ValueMember := 'CATEGORYNO';
  category3ComboBox.DataBindings.Add('SelectedValue', contactsDataTable, 'CATEGORY3');
  //Setup grid with single column against calculated field
  contactsDataGrid.SetDataBinding(contactsDataTable, '');
  mappingName := contactsDataTable.TableName;
  ts := DataGridTableStyle.Create;
  ts.MappingName := mappingName;
  ts.AllowSorting := False;
  col := DataGridTextBoxColumn.Create;
  col.HeaderText := 'Full Name';
  col.MappingName := 'FullName';
  col.Width := 160;
  ts.GridColumnStyles.Add(col);
  contactsDataGrid.TableStyles.Clear;
  contactsDataGrid.TableStyles.Add(ts);

  SetupTabs(addressTabControl, addressTypesDataTable, addressTypelist,
    'AddressTypeNo', 'AddressType');

  contactDetailsDataAdapter := FbDataAdapter.Create(
    'select * from CONTACTDETAILS', phlabConnection);
  contactDetailsCommandBuilder := FbCommandBuilder.Create(contactDetailsDataAdapter);
  contactDetailsDataAdapter.InsertCommand := contactDetailsCommandBuilder.GetInsertCommand;
  contactDetailsDataAdapter.DeleteCommand := contactDetailsCommandBuilder.GetDeleteCommand;
  contactDetailsDataAdapter.UpdateCommand := contactDetailsCommandBuilder.GetUpdateCommand;
  contactDetailsDataAdapter.Fill(phlabDataSet, 'ContactDetails');
  contactDetailsDataTable := phlabDataset.Tables['ContactDetails'];
  contactDetailsDataView := DataView.Create(contactDetailsDataTable);

  buildingTextBox.DataBindings.Add( 'Text', contactDetailsDataView, 'BUILDING');
  streetTextBox.DataBindings.Add(   'Text', contactDetailsDataView, 'STREET');
  villageTextBox.DataBindings.Add(  'Text', contactDetailsDataView, 'VILLAGE');
  townTextBox.DataBindings.Add(     'Text', contactDetailsDataView, 'TOWN');
  countyTextBox.DataBindings.Add(   'Text', contactDetailsDataView, 'COUNTY');
  postCodeTextBox.DataBindings.Add( 'Text', contactDetailsDataView, 'POSTCODE');
  countryTextBox.DataBindings.Add(  'Text', contactDetailsDataView, 'COUNTRY');
  webSiteTextBox.DataBindings.Add(  'Text', contactDetailsDataView, 'WEBSITE');
  emailTextBox.DataBindings.Add(    'Text', contactDetailsDataView, 'EMAILADDRESS');
  mobileTextBox.DataBindings.Add(   'Text', contactDetailsDataView, 'MOBILE');
  telephoneTextBox.DataBindings.Add('Text', contactDetailsDataView, 'TELNO');

  controlSelectCommand := FbCommand.Create(
    'select NEXTCONTACTNO from CONTROL', phlabConnection);

  contactsCurrencyManager := CurrencyManager(BindingContext[contactsDataTable]);
  Include(contactsCurrencyManager.PositionChanged, ContactsCurrencyManagerScroll);

  //Cause current category's contacts to be loaded into the DataTable,
  categoryTabControl_SelectedIndexChanged(categoryTabControl, EventArgs.Create);
  //Cause current contact address to be loaded into the DataTable,
  addressTabControl_SelectedIndexChanged(addressTabControl, EventArgs.Create);
end;

procedure MainForm.ContactsCurrencyManagerScroll(Sender: &Object; e: EventArgs);
begin
  LoadSelectedAddress
end;

procedure MainForm.SearchForName(const name: String; searchStart: Boolean);
var
  startIndex, rowIndex: Integer;
begin
  //A DataTable's Rows collection has a Find method, but it relies on the
  //table being sorted on the search field, which this one isn't.
  //So we'll do this manually
  startIndex := 0;
  if not searchStart then
    startIndex := contactsCurrencyManager.Position + 1;
  for rowIndex := startIndex to contactsDataTable.Rows.Count - 1 do
  begin
    if contactsDataTable.Rows[rowIndex]['FullName'].
         ToString.ToLower.IndexOf(name.ToLower) >= 0 then
    begin
      contactsCurrencyManager.Position := rowIndex;
      Break
    end;
  end;
end;

procedure MainForm.searchNextButton_Click(sender: System.Object; e: System.EventArgs);
begin
  SearchForName(nameTextBox.Text, False);
end;

procedure MainForm.searchStartButton_Click(sender: System.Object; e: System.EventArgs);
begin
  SearchForName(nameTextBox.Text, True);
end;

procedure MainForm.addressTabControl_SelectedIndexChanged(sender: System.Object;
  e: System.EventArgs);
begin
  LoadSelectedAddress
end;

procedure MainForm.categoryTabControl_SelectedIndexChanged(sender: System.Object;
  e: System.EventArgs);
begin
  LoadContacts
end;

procedure MainForm.SaveChangesIfNeeded;
var
  row: DataRow;
  categories: StringBuilder;
begin
  if editingContact then
  begin
    //save changes to contact details using the adapter's commands
    contactDetailsDataAdapter.Update(contactDetailsDataTable);
    //save changes to contact using explicit command (rather more work....)
    row := contactsDataTable.Rows[contactsCurrencyManager.Position];
    with contactsUpdateCommand.Parameters do
    begin
      Item['@COMPANYNAME'].Value := row['COMPANYNAME'];
      Item['@TITLENO'].Value     := row['TITLENO'];
      Item['@FIRSTNAME'].Value   := row['FIRSTNAME'];
      Item['@LASTNAME'].Value    := row['LASTNAME'];
      Item['@NICKNAME'].Value    := row['NICKNAME'];
      Item['@DATEOFBIRTH'].Value := row['DATEOFBIRTH'];
      Item['@CATEGORIES'].Value  := row['CATEGORIES'];
      Item['@NOTES'].Value       := row['NOTES'];
      //Fabricate the CATEGORIES field
      categories := StringBuilder.Create;
      if (row['CATEGORY1'] <> DBNull.Value) and (Convert.ToInt16(row['CATEGORY1']) <> 0) then
      begin
        categories.Append(',');
        categories.Append(row['CATEGORY1']);
      end;
      if (row['CATEGORY2'] <> DBNull.Value) and (Convert.ToInt16(row['CATEGORY2']) <> 0) then
      begin
        categories.Append(',');
        categories.Append(row['CATEGORY2']);
      end;
      if (row['CATEGORY3'] <> DBNull.Value) and (Convert.ToInt16(row['CATEGORY3']) <> 0) then
      begin
        categories.Append(',');
        categories.Append(row['CATEGORY3']);
      end;
      if categories.Length > 0 then
        categories.Append(',');
      Item['@CATEGORIES'].Value  := categories.ToString;
      Item['@CATEGORY2'].Value   := row['CATEGORY2'];
      Item['@CATEGORY3'].Value   := row['CATEGORY3'];
      Item['@CONTACTNO'].Value   := row['CONTACTNO'];
    end;
    contactsUpdateCommand.ExecuteNonQuery;
  end
end;

//Recursive routine to set the data bound controls editable or not
procedure MainForm.SetupControls(aControl: Control; readOnly: Boolean);
var
  child: Control;
begin
  if (aControl is TextBox) or (aControl is ComboBox) or (aControl is DateTimePicker) then
  begin
    aControl.BackColor := uiBackColours[readOnly];
    aControl.Enabled := not readOnly;
  end;
  for child in aControl.Controls do
    SetupControls(child, readOnly)
end;

//Makes tabs from captions in table, and stores key fields in array list
procedure MainForm.SetupTabs(theTabControl: TabControl; table: DataTable;
  list: ArrayList; keyField, displayField: String);
var
  row: DataRow;
begin
  for row in table.Rows do
  begin
    list.Add(row[keyField]);
    theTabControl.TabPages.Add(TabPage.Create(row[displayField].ToString));
  end;
end;

//Takes a row from the Contacts table & makes a full name from various columns
function MainForm.ContactDisplayName(row: DataRow): String;
var
  name: StringBuilder;
begin
  name := StringBuilder.Create(row['Title'].ToString);
  if name.Length > 0 then
    name.Append('. ');
  name.Append(row['FirstName'].ToString);
  if row['FirstName'].ToString.Length > 0 then
    name.Append(' ');
  name.Append(row['LastName'].ToString);
  if row['NickName'].ToString.Length > 0 then
    if name.Length = 0 then
      name.Append(row['Nickname'].ToString)
    else
      name.Append(System.String.Format(' ({0})', row['Nickname']));
  Result := name.ToString;
end;

//Load one of the contact addresses by filtering the view
procedure MainForm.LoadSelectedAddress;
var
  contactNo, addressTypeNo: Integer;
  row: DataRow;
begin
  //Sometimes this routine gets called (from the currency
  //manager scroll event) when Contacts is empty
  if contactsDataTable.Rows.Count > 0 then
  begin
    //The values are actually smallints (Int16), not integers (Int32)
    contactNo := Convert.ToInt32(contactsDataTable.Rows[contactsCurrencyManager.Position]['ContactNo']);
    addressTypeNo := Convert.ToInt32(addressTypeList[addressTabControl.SelectedIndex]);
    contactDetailsDataView.RowFilter := System.String.Format(
      '(ContactNo = {0}) and (AddressTypeNo = {1})', contactNo, addressTypeNo);
    //If there is no address record, we need to add one, if editing
    if editingContact and (contactDetailsDataView.Count = 0) then
    begin
      contactDetailsDataTable.BeginLoadData;
      try
        row := contactDetailsDataTable.NewRow;
        row['UserNo'] := 0; //Only working with UserNo=0 in this app
        row['ContactNo'] := contactNo;
        row['AddressTypeNo'] := addressTypeNo;
        contactDetailsDataTable.Rows.Add(row)
      finally
        contactDetailsDataTable.EndLoadData
      end
    end
  end
end;

//Load the current category's contacts details into the Contacts DataTable. A
//calculated field is loaded into an additional column in the contacts DataTable
procedure MainForm.LoadContacts;
var
  sql: String;
  row: DataRow;
  categoryNo: Integer;
begin
  contactsDataTable.BeginLoadData;
  try
    if contactsDataTable.Columns.Count > 0 then
      contactsDataTable.Columns.Remove('FullName');
    contactsDataTable.Clear;

    SQL := sSelectContacts;

    //Value is likely to be a Smallint. Doing a parse is more likely to succeed
    CategoryNo := System.Int32.Parse(categoryList[categoryTabControl.SelectedIndex].ToString);
    if categoryNo <> 0 then //not All Categories, so there is going to be a "where" clause
      SQL := SQL + System.String.Format(' where Categories like ''%,{0},%''', categoryNo);
    SQL := SQL + ' order By LastName, FirstName';
    contactsDataAdapter.SelectCommand.CommandText := SQL;
    contactsDataAdapter.Fill(contactsDataTable);

    contactsDataTable.Columns.Add('FullName');
    for row in contactsDataTable.Rows do
      row['FullName'] := ContactDisplayName(row)
  finally
    contactsDataTable.EndLoadData
  end
end;

procedure MainForm.editContactLinkLabel_LinkClicked(sender: System.Object; e: System.Windows.Forms.LinkLabelLinkClickedEventArgs);
const
  captions: array[Boolean] of String = ('Save', 'Edit');
var
  oldPos: Integer;
begin
  SaveChangesIfNeeded;
  editContactLinkLabel.Text := captions[editingContact];
  SetupControls(mainClientPanel, editingContact);
  editingContact := not editingContact;
  if not editingContact then
  begin
    oldPos := contactsCurrencyManager.Position;
    LoadContacts; //refresh grid with saved contact details
    contactsCurrencyManager.Position := oldPos;
  end
end;

procedure MainForm.deleteContactLinkLabel_LinkClicked(sender: System.Object;
  e: System.Windows.Forms.LinkLabelLinkClickedEventArgs);
var
  contactName, oldSort: String;
  contactNo: Integer;
  row: DataRowView;
begin
  SaveChangesIfNeeded;
  contactName := contactsDataTable.Rows[contactsCurrencyManager.Position]['FullName'].ToString;
  contactNo := Convert.ToInt32(contactsDataTable.Rows[contactsCurrencyManager.Position]['ContactNo']);
  if (contactName.Length = 0) or
     (MessageBox.Show(
        System.String.Format('Delete {0}?', contactName), 'Confirmation',
        MessageBoxButtons.YesNo, MessageBoxIcon.Warning) <>
      System.Windows.Forms.DialogResult.No) then
  begin
    //Delete each contact detail record
    oldSort := contactDetailsDataView.Sort;
    contactDetailsDataView.Sort := 'ContactNo';
    for row in contactDetailsDataView.FindRows(contactNo) do
      row.Delete;
    contactDetailsDataView.Sort := oldSort;
    contactDetailsDataAdapter.Update(contactDetailsDataTable);
    //Delete contact record
    contactsDeleteCommand.Parameters['@ContactNo'].Value := contactNo;
    contactsDeleteCommand.ExecuteNonQuery;
    LoadContacts
  end;
end;

procedure MainForm.newContactLinkLabel_LinkClicked(sender: System.Object; e: System.Windows.Forms.LinkLabelLinkClickedEventArgs);
var
  oldSort: String;
  row: DataRowView;
begin
  SaveChangesIfNeeded;
  if editingContact then //come out of editmode
    editContactLinkLabel_LinkClicked(editContactLinkLabel, LinkLabelLinkClickedEventArgs.Create(editContactLinkLabel.Links[0]));

  //Insert a new contact record, which will fire a trigger to add a new unique
  //ContactNo in the Contacts.ContactNo field and also Control.NextContactNo
  contactsInsertCommand.ExecuteNonQuery;

  //This will read the records back in with the new ContactNo
  LoadContacts;
  //Move to last (i.e. new) contact
  oldSort := contactsDataView.Sort;
  contactsDataView.Sort := 'ContactNo';
  contactsCurrencyManager.Position := contactsDataView.Count - 1;
  //Set up some other sensible field values in addition to ContactNo
  row := contactsDataView[contactsCurrencyManager.Position];
  row['UserNo'] := 0; //Only working with UserNo=0 in this app
  row['Category1'] := categoryList[categoryTabControl.SelectedIndex];
  contactsDataView.Sort := oldSort;

  // Show Edit Mode
  editContactLinkLabel_LinkClicked(editContactLinkLabel, LinkLabelLinkClickedEventArgs.Create(editContactLinkLabel.Links[0]));

  //Go to the sensible details page
  contactDetailsTabControl.SelectedTab := contactNamesTabPage;
  titleComboBox.Focus;
  titleComboBox.DroppedDown := True
end;

end.
